/*
 * This file is generated by jOOQ.
 */
package de.ship.db.tables;


import de.ship.db.CommonDd;
import de.ship.db.Keys;
import de.ship.db.tables.TCoreElementHierarchyAndGroup.TCoreElementHierarchyAndGroupPath;
import de.ship.db.tables.records.TCoreElementHierarchyGroupRecord;

import java.time.LocalDateTime;
import java.util.Collection;

import org.jooq.Condition;
import org.jooq.Field;
import org.jooq.ForeignKey;
import org.jooq.Identity;
import org.jooq.InverseForeignKey;
import org.jooq.Name;
import org.jooq.Path;
import org.jooq.PlainSQL;
import org.jooq.QueryPart;
import org.jooq.Record;
import org.jooq.SQL;
import org.jooq.Schema;
import org.jooq.Select;
import org.jooq.Stringly;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.TableOptions;
import org.jooq.UniqueKey;
import org.jooq.impl.DSL;
import org.jooq.impl.SQLDataType;
import org.jooq.impl.TableImpl;


/**
 * group multiple hierarchy elements as group with min and max to define how
 * many of these variables must be filled out. Currently used in interview only.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class TCoreElementHierarchyGroup extends TableImpl<TCoreElementHierarchyGroupRecord> {

    private static final long serialVersionUID = 1L;

    /**
     * The reference instance of
     * <code>common_dd.t_core_element_hierarchy_group</code>
     */
    public static final TCoreElementHierarchyGroup T_CORE_ELEMENT_HIERARCHY_GROUP = new TCoreElementHierarchyGroup();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<TCoreElementHierarchyGroupRecord> getRecordType() {
        return TCoreElementHierarchyGroupRecord.class;
    }

    /**
     * The column
     * <code>common_dd.t_core_element_hierarchy_group.lastchange</code>.
     */
    public final TableField<TCoreElementHierarchyGroupRecord, LocalDateTime> LASTCHANGE = createField(DSL.name("lastchange"), SQLDataType.LOCALDATETIME(6).defaultValue(DSL.field(DSL.raw("now()"), SQLDataType.LOCALDATETIME)), this, "");

    /**
     * The column <code>common_dd.t_core_element_hierarchy_group.pk</code>.
     */
    public final TableField<TCoreElementHierarchyGroupRecord, Integer> PK = createField(DSL.name("pk"), SQLDataType.INTEGER.nullable(false).identity(true), this, "");

    /**
     * The column <code>common_dd.t_core_element_hierarchy_group.min</code>.
     */
    public final TableField<TCoreElementHierarchyGroupRecord, Integer> MIN = createField(DSL.name("min"), SQLDataType.INTEGER.nullable(false), this, "");

    /**
     * The column <code>common_dd.t_core_element_hierarchy_group.max</code>.
     */
    public final TableField<TCoreElementHierarchyGroupRecord, Integer> MAX = createField(DSL.name("max"), SQLDataType.INTEGER.nullable(false), this, "");

    private TCoreElementHierarchyGroup(Name alias, Table<TCoreElementHierarchyGroupRecord> aliased) {
        this(alias, aliased, (Field<?>[]) null, null);
    }

    private TCoreElementHierarchyGroup(Name alias, Table<TCoreElementHierarchyGroupRecord> aliased, Field<?>[] parameters, Condition where) {
        super(alias, null, aliased, parameters, DSL.comment("group multiple hierarchy elements as group with min and max to define how many of these variables must be filled out. Currently used in interview only."), TableOptions.table(), where);
    }

    /**
     * Create an aliased <code>common_dd.t_core_element_hierarchy_group</code>
     * table reference
     */
    public TCoreElementHierarchyGroup(String alias) {
        this(DSL.name(alias), T_CORE_ELEMENT_HIERARCHY_GROUP);
    }

    /**
     * Create an aliased <code>common_dd.t_core_element_hierarchy_group</code>
     * table reference
     */
    public TCoreElementHierarchyGroup(Name alias) {
        this(alias, T_CORE_ELEMENT_HIERARCHY_GROUP);
    }

    /**
     * Create a <code>common_dd.t_core_element_hierarchy_group</code> table
     * reference
     */
    public TCoreElementHierarchyGroup() {
        this(DSL.name("t_core_element_hierarchy_group"), null);
    }

    public <O extends Record> TCoreElementHierarchyGroup(Table<O> path, ForeignKey<O, TCoreElementHierarchyGroupRecord> childPath, InverseForeignKey<O, TCoreElementHierarchyGroupRecord> parentPath) {
        super(path, childPath, parentPath, T_CORE_ELEMENT_HIERARCHY_GROUP);
    }

    /**
     * A subtype implementing {@link Path} for simplified path-based joins.
     */
    public static class TCoreElementHierarchyGroupPath extends TCoreElementHierarchyGroup implements Path<TCoreElementHierarchyGroupRecord> {

        private static final long serialVersionUID = 1L;
        public <O extends Record> TCoreElementHierarchyGroupPath(Table<O> path, ForeignKey<O, TCoreElementHierarchyGroupRecord> childPath, InverseForeignKey<O, TCoreElementHierarchyGroupRecord> parentPath) {
            super(path, childPath, parentPath);
        }
        private TCoreElementHierarchyGroupPath(Name alias, Table<TCoreElementHierarchyGroupRecord> aliased) {
            super(alias, aliased);
        }

        @Override
        public TCoreElementHierarchyGroupPath as(String alias) {
            return new TCoreElementHierarchyGroupPath(DSL.name(alias), this);
        }

        @Override
        public TCoreElementHierarchyGroupPath as(Name alias) {
            return new TCoreElementHierarchyGroupPath(alias, this);
        }

        @Override
        public TCoreElementHierarchyGroupPath as(Table<?> alias) {
            return new TCoreElementHierarchyGroupPath(alias.getQualifiedName(), this);
        }
    }

    @Override
    public Schema getSchema() {
        return aliased() ? null : CommonDd.COMMON_DD;
    }

    @Override
    public Identity<TCoreElementHierarchyGroupRecord, Integer> getIdentity() {
        return (Identity<TCoreElementHierarchyGroupRecord, Integer>) super.getIdentity();
    }

    @Override
    public UniqueKey<TCoreElementHierarchyGroupRecord> getPrimaryKey() {
        return Keys.PK_CORE_ELEMENT_HIERARCHY_GROUP;
    }

    private transient TCoreElementHierarchyAndGroupPath _tCoreElementHierarchyAndGroup;

    /**
     * Get the implicit to-many join path to the
     * <code>common_dd.t_core_element_hierarchy_and_group</code> table
     */
    public TCoreElementHierarchyAndGroupPath tCoreElementHierarchyAndGroup() {
        if (_tCoreElementHierarchyAndGroup == null)
            _tCoreElementHierarchyAndGroup = new TCoreElementHierarchyAndGroupPath(this, null, Keys.T_CORE_ELEMENT_HIERARCHY_AND_GROUP__FK_CORE_ELEMENT_HIERARCHY_AND_GROUP_FK_ELEMENT.getInverseKey());

        return _tCoreElementHierarchyAndGroup;
    }

    @Override
    public TCoreElementHierarchyGroup as(String alias) {
        return new TCoreElementHierarchyGroup(DSL.name(alias), this);
    }

    @Override
    public TCoreElementHierarchyGroup as(Name alias) {
        return new TCoreElementHierarchyGroup(alias, this);
    }

    @Override
    public TCoreElementHierarchyGroup as(Table<?> alias) {
        return new TCoreElementHierarchyGroup(alias.getQualifiedName(), this);
    }

    /**
     * Rename this table
     */
    @Override
    public TCoreElementHierarchyGroup rename(String name) {
        return new TCoreElementHierarchyGroup(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public TCoreElementHierarchyGroup rename(Name name) {
        return new TCoreElementHierarchyGroup(name, null);
    }

    /**
     * Rename this table
     */
    @Override
    public TCoreElementHierarchyGroup rename(Table<?> name) {
        return new TCoreElementHierarchyGroup(name.getQualifiedName(), null);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreElementHierarchyGroup where(Condition condition) {
        return new TCoreElementHierarchyGroup(getQualifiedName(), aliased() ? this : null, null, condition);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreElementHierarchyGroup where(Collection<? extends Condition> conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreElementHierarchyGroup where(Condition... conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreElementHierarchyGroup where(Field<Boolean> condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TCoreElementHierarchyGroup where(SQL condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TCoreElementHierarchyGroup where(@Stringly.SQL String condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TCoreElementHierarchyGroup where(@Stringly.SQL String condition, Object... binds) {
        return where(DSL.condition(condition, binds));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TCoreElementHierarchyGroup where(@Stringly.SQL String condition, QueryPart... parts) {
        return where(DSL.condition(condition, parts));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreElementHierarchyGroup whereExists(Select<?> select) {
        return where(DSL.exists(select));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreElementHierarchyGroup whereNotExists(Select<?> select) {
        return where(DSL.notExists(select));
    }
}
